// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

const nsIGmailManager = Components.interfaces.nsIGmailManager
const nsIObserverService = Components.interfaces.nsIObserverService;

var gAccounts = {
  _manager: null,
  _type: null,
  _current: null,
  
  load: function()
  {
    var bundle = document.getElementById("gm-accounts-bundle");
    
    try {
      this._manager = Components.classes["@longfocus.com/gmanager/manager;1"].getService(nsIGmailManager);
      this._type = window.arguments[0];
      this._current = window.arguments[1];
    } catch(e) {}
    
    switch (this._type) {
      case "Add":
        document.getElementById("gm-accounts-info").value = "Add a new gmail account";
        document.getElementById("gm-accounts-username").value = "";
        document.getElementById("gm-accounts-username").select();
        break;
      case "Rename":
        var account = this._manager.getAccount(this._current);
        document.getElementById("gm-accounts-info").value = "Rename the current gmail account";
        document.getElementById("gm-accounts-username").value = account.username;
        document.getElementById("gm-accounts-username").select();
        break;
      case "Remove":
        var account = this._manager.getAccount(this._current);
        document.getElementById("gm-accounts-info").value = "Remove the current gmail account";
        document.getElementById("gm-accounts-username").value = account.username;
        document.getElementById("gm-accounts-username").disabled = true;
        break;
    };
  },
  
  accept: function()
  {
    switch (this._type) {
      case "Add":
        this._manager.addAccount(document.getElementById("gm-accounts-username").value, null);
        break;
      case "Rename":
        this._manager.renameAccount(this._current, document.getElementById("gm-accounts-username").value);
        break;
      case "Remove":
        this._manager.removeAccount(this._current);
        break;
    };
    
    var observer = Components.classes["@mozilla.org/observer-service;1"].getService(nsIObserverService);
    observer.notifyObservers(null, "prefs-account-change", this._type);
    
    window.close();
  }
}