// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var gOverlayPopup = {
  populate: function()
  {
    var bundle = document.getElementById("gm-statusbar-bundle");
    var popup = document.getElementById("gm-statusbar-popup");
    var numAccounts = gOverlay._manager.getNumAccounts();
    var isDisabled = gOverlay._branch.getBoolPref("gmailweb");
    var item = null;
    
    while (popup.hasChildNodes())
      popup.removeChild(popup.lastChild);
    
    if (numAccounts > 0) {
      if (isDisabled) {
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-overlay-menuitem-signout");
        item.setAttribute("label", "Sign out of Gmail");
        item.setAttribute("oncommand", "gOverlay.select(this.id);");
        popup.appendChild(item);
        
        popup.appendChild(document.createElement("menuseparator"));
      }
      
      if (numAccounts > 1) {
        var numLoggedIn = 0;
        
        for (var i = 0; i < numAccounts; i++) {
          var account = gOverlay._manager.getAccount(i);
          if (account.loggedIn) numLoggedIn++;
        }
        
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-overlay-menuitem-loginall");
        item.setAttribute("label", bundle.getString("sbar-popup-all-login"));
        item.setAttribute("oncommand", "gOverlay.select(this.id);");
        item.setAttribute("disabled", isDisabled ? true : (numLoggedIn == numAccounts));
        popup.appendChild(item);
        
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-overlay-menuitem-logoutall");
        item.setAttribute("label", bundle.getString("sbar-popup-all-logout"));
        item.setAttribute("oncommand", "gOverlay.select(this.id);");
        item.setAttribute("disabled", isDisabled ? true : (numLoggedIn == 0));
        popup.appendChild(item);
        
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-overlay-menuitem-all-checknow");
        item.setAttribute("label", bundle.getString("sbar-popup-all-check"));
        item.setAttribute("oncommand", "gOverlay.select(this.id);");
        item.setAttribute("disabled", isDisabled ? true : (numLoggedIn == 0));
        popup.appendChild(item);
        
        popup.appendChild(document.createElement("menuseparator"));
      }
      
      if (gOverlay._current) {
        var account = gOverlay._manager.getAccount(gOverlay._current);
        
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-overlay-menuitem-loginout");
        item.setAttribute("label", account.loggedIn ? bundle.getString("sbar-popup-selected-logout") : 
									bundle.getString("sbar-popup-selected-login"));
        item.setAttribute("oncommand", "gOverlay.select(this.id);");
        item.setAttribute("disabled", isDisabled);
        popup.appendChild(item);
        
        if (account.loggedIn) {
          item = document.createElement("menuitem");
          item.setAttribute("id", "gm-overlay-menuitem-checknow");
          item.setAttribute("label", bundle.getString("sbar-popup-selected-check"));
          item.setAttribute("oncommand", "gOverlay.select(this.id);");
          item.setAttribute("disabled", isDisabled);
          popup.appendChild(item);
          
          item = document.createElement("menuitem");
          item.setAttribute("id", "gm-overlay-menuitem-showsnippets");
          item.setAttribute("label", "Show new mail snippets...");
          item.setAttribute("oncommand", "gOverlay.select(this.id);");
          item.setAttribute("disabled", isDisabled ? true : (account.inboxUnread == 0));
          popup.appendChild(item);
        }
        
        popup.appendChild(document.createElement("menuseparator"));
      }
      
      for (var i = 0; i < numAccounts; i++) {
        var account = gOverlay._manager.getAccount(i);
        var label = account.username;
        
        label += (account.loggedIn ? " (" + account.inboxUnread + ")" : "");
        //label += " (logged " + (account.loggedIn ? "in" : "out") + ")";
        //label += " ... logged " + (account.loggedIn ? "in" : "out");
        
        item = document.createElement("menuitem");
        item.setAttribute("id", account.username);
        item.setAttribute("label", label);
        item.setAttribute("type", "radio");
        item.setAttribute("name", "gmailAccount");
        item.setAttribute("value", i);
        item.setAttribute("oncommand", "gOverlay.selectAccount(this.value, true);");
        item.setAttribute("checked", (gOverlay._current == i));
        item.setAttribute("disabled", isDisabled);
        item.setAttribute("default", account.loggedIn);
        popup.appendChild(item);
      }
    }
    else {
      item = document.createElement("menuitem");
      item.setAttribute("label", bundle.getString("sbar-popup-add-account"));
      item.setAttribute("oncommand", "window.openDialog('chrome://gmanager/content/accounts.xul', null, 'chrome, dependent=yes', 'Add');");
      popup.appendChild(item);
    }
    
    popup.appendChild(document.createElement("menuseparator"));
    
    item = document.createElement("menuitem");
    item.setAttribute("label", bundle.getString("sbar-popup-prefs"));
    item.setAttribute("oncommand", "window.openDialog('chrome://gmanager/content/preferences.xul', null, 'chrome, dependent=yes');");
    popup.appendChild(item);
  }
}