// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var gOverlayTooltip = {
  _account: null,
  
  populate: function()
  {
    document.getElementById("gm-statusbar-tooltip-none").setAttribute("hidden", "true");
    document.getElementById("gm-statusbar-tooltip-error").setAttribute("hidden", "true");
    document.getElementById("gm-statusbar-tooltip-timeout").setAttribute("hidden", "true");
    document.getElementById("gm-statusbar-tooltip-logged-out").setAttribute("hidden", "true");
    document.getElementById("gm-statusbar-tooltip-logged-in").setAttribute("hidden", "true");
    
    if (!gOverlay._current) {
      document.getElementById("gm-statusbar-tooltip-none").setAttribute("hidden", "false");
    }
    else {
      this._account = gOverlay._manager.getAccount(gOverlay._current);
      
      switch (this._account.status) {
        case GMAIL_ACCOUNT_STATE_ERROR:
          document.getElementById("gm-statusbar-tooltip-error").setAttribute("hidden", "false");
          break;
        case GMAIL_ACCOUNT_STATE_TIMEOUT:
          document.getElementById("gm-statusbar-tooltip-timeout").setAttribute("hidden", "false");
          break;
        case GMAIL_ACCOUNT_STATE_LOGGED_OUT:
          document.getElementById("gm-statusbar-tooltip-logged-out").setAttribute("hidden", "false");
          break;
        case GMAIL_ACCOUNT_STATE_LOGGED_IN:
          this.loggedIn();
          break;
      }
    }
  },
  
  loggedIn: function()
  {
    var bundle = document.getElementById("gm-statusbar-bundle");
    var element = null;
    
    element = document.getElementById("gm-statusbar-tooltip-logged-in-username");
    element.setAttribute("value", this._account.username);
    
    element = document.getElementById("gm-statusbar-tooltip-logged-in-inbox");
    element.setAttribute("value", bundle.getFormattedString("sbar-tooltip-inbox", [this._account.inboxUnread]));
    
    element = document.getElementById("gm-statusbar-tooltip-logged-in-drafts");
    element.setAttribute("value", bundle.getFormattedString("sbar-tooltip-drafts", [this._account.savedDrafts]));
    element.setAttribute("hidden", (this._account.savedDrafts == 0));
    
    element = document.getElementById("gm-statusbar-tooltip-logged-in-spam");
    element.setAttribute("value", bundle.getFormattedString("sbar-tooltip-spam", [this._account.spamUnread]));
    element.setAttribute("hidden", (this._account.spamUnread == 0));
    
    var parent = document.getElementById("gm-statusbar-tooltip-logged-in-labels");
    parent.setAttribute("hidden", "true");
    
    while (parent.hasChildNodes())
      parent.removeChild(parent.lastChild);
    
    for (var i = 0; i < this._account.getNumLabels(); i++) {
      var label = this._account.getLabel(i).split(",");
      var name = label[0];
      var unread = label[1];
      
      element = document.createElement("label");
      element.setAttribute("style", "margin:0; font-size:9px;");
      
      if (unread > 0) {
        element.setAttribute("style", "margin:0; font-weight:bold;");
        name += " (" + unread + ")";
      }
      
      element.setAttribute("value", name);
      
      if (unread > 0) {
        parent.appendChild(element);
        parent.setAttribute("hidden", "false");
      }
    }
    
    element = document.getElementById("gm-statusbar-tooltip-logged-in-space");
    element.setAttribute("value", bundle.getFormattedString("sbar-tooltip-space",
                         [this._account.spaceUsed, this._account.percentUsed, this._account.totalSpace]));
    
    var sep = document.getElementById("gm-statusbar-tooltip-logged-in-snippets-sep");
    sep.setAttribute("hidden", "true");
    
    var parent = document.getElementById("gm-statusbar-tooltip-logged-in-snippets");
    parent.setAttribute("hidden", "true");
    
    while (parent.hasChildNodes())
      parent.removeChild(parent.lastChild);
    
    if (gOverlay._branch.getBoolPref("tooltip-snippets")) {
      for (var i = 0; i < this._account.getNumSnippets(); i++) {
        var subj = this._account.getSnippetSubject(i);
        var msg = this._account.getSnippetMsg(i);
        
        element = document.createElement("label");
        element.setAttribute("style", "margin:2px; margin-top:8px; font-size:10px; font-weight:bold;");
        element.setAttribute("value", (i+1) + ". " + subj);
        parent.appendChild(element);
        
        element = document.createElement("label");
        element.setAttribute("style", "margin:2px; font-size:9px;");
        element.setAttribute("value", msg);
        parent.appendChild(element);
      }
      
      if (this._account.getNumSnippets() > 0) {
        sep.setAttribute("hidden", "false");
        parent.setAttribute("hidden", "false");
      }
    }
    
    document.getElementById("gm-statusbar-tooltip-logged-in").setAttribute("hidden", "false");
  }
}